local mstbuff = Buffs.VeterancyStorageBuff.Affects.MassStorageBuf.Mult - 1
local estbuff = Buffs.VeterancyStorageBuff.Affects.EnergyStorageBuf.Mult-1

local oldUnit=Unit
Unit = Class(oldUnit) {

    OnCreate = function(self)
        oldUnit.OnCreate(self)
        local bp = self:GetBlueprint()
        if bp.Economy.XPperLevel then                         self.XPnextLevel = bp.Economy.XPperLevel
            self.xp = 0
            self.VeteranLevel = 1
            self.LevelProgress = 1
            self.Sync.LevelProgress = self.LevelProgress
            self.Sync.RegenRate = bp.Defense.RegenRate
        end
    end,

    OnStartBeingBuilt = function(self, builder, layer)
        if builder.LevelProgress and builder.LevelProgress > 5 and builder.vetToggle and builder.vetToggle > 0 and not self:GetBlueprint().Economy.vetBuild then
            local bp = self:GetBlueprint().Economy
            bp.vetBuild = (builder.LevelProgress-1)* builder.vetToggle
            self.Sync.vetBuild = bp.vetBuild
        end
        oldUnit.OnStartBeingBuilt(self, builder, layer)
    end,

    OnStopBeingBuilt = function(self, builder, layer)
        if self:GetBlueprint().Economy.xpTimeStep and EntityCategoryContains(categories.ENERGYPRODUCTION + categories.MASSSTORAGE + categories.ENERGYSTORAGE, self) then
            self:ForkThread(self.XPOverTime)
        end        oldUnit.OnStopBeingBuilt(self, builder, layer)
        local bp = self:GetBlueprint().Economy
        if bp.vetBuild and bp.vetBuild > 1 then
            self:AddLevels(bp.vetBuild * 0.05)             bp.vetBuild = nil
            self.Sync.vetBuild = 0
        end
    end,

    OnStopBuild = function(self, unitBeingBuilt)
                local sbp = self:GetBlueprint()
        if unitBeingBuilt and not unitBeingBuilt:IsDead() and not unitBeingBuilt.MissileBuilt and not unitBeingBuilt:IsBeingBuilt() and not unitBeingBuilt:IsUnitState("SiloBuildingAmmo") and sbp.Economy.xpValue and sbp.Economy.xpValue > 0 and sbp.Economy.BuildXPLevelpSecond and sbp.Economy.BuildXPLevelpSecond > 0 and (unitBeingBuilt:GetHealth() == unitBeingBuilt:GetMaxHealth())  and  unitBeingBuilt:GetWorkProgress() == 0 then
            local bp = unitBeingBuilt:GetBlueprint().Economy
            if bp.xpValue and bp.xpValue > 0  then
                                                                                                                                                                                                                local vetmult = 1
                if unitBeingBuilt.LevelProgress > 1 then
                    vetmult = vetmult + (unitBeingBuilt.LevelProgress-1)*0.2
                end                self:AddXP(bp.xpValue * 0.25 * vetmult)            end
        end
        oldUnit.OnStopBuild(self, unitBeingBuilt)
    end,

    WorkingState = State {
        OnWorkEnd = function(self, work)            local enhBp = self:GetBlueprint().Enhancements[work]
            local enhxp = math.pow(enhBp.BuildCostMass + enhBp.BuildCostEnergy*0.1 + enhBp.BuildTime*0.04,0.5)
                        local mult = self.LevelProgress-0.9999
            if ScenarioInfo.ALLies == false then mult = 0 end
            self:AddXP(enhxp * (100 + (4*(mult)))*.01)
            oldUnit.WorkingState.OnWorkEnd(self, work)
        end,
    },

            SetMaintenanceConsumptionActive = function(self)
        if self.XPOverTimeThread then KillThread(self.XPOverTimeThread) end
        self.XPOverTimeThread = ForkThread(self.XPOverTime, self)
        oldUnit.SetMaintenanceConsumptionActive(self)
    end,

    XPOverTime = function(self)
        if not self:GetBlueprint().Economy.xpTimeStep then return end         if self:GetBlueprint().Economy.xpTimeStep <= 0 then return end
        local waittime = self:GetBlueprint().Economy.xpTimeStep * 0.5
        local step = 0.75        if ScenarioInfo.ALLies == false then step = 0.34 end
        WaitSeconds(waittime)         while not self:IsDead() and (self.MaintenanceConsumption or EntityCategoryContains(categories.ENERGYPRODUCTION + categories.MASSSTORAGE + categories.ENERGYSTORAGE, self))do
            self:AddXP(self.XPnextLevel* step)
            WaitSeconds(waittime)
        end
    end,

        startBuildXPThread = function(self)
        local levelPerSecond = self:GetBlueprint().Economy.BuildXPLevelpSecond
        if not levelPerSecond then return end
        if  levelPerSecond <= 0 then return end
        WaitTicks(2)        if not self:IsDead() and self.ActiveConsumption then
            self:AddXP(self.XPnextLevel*levelPerSecond*0.017)        else
            return
        end
        WaitTicks(10)
        if not self:IsDead() and self.ActiveConsumption then
            self:AddXP(self.XPnextLevel*levelPerSecond*0.017)        else
            return
        end
        WaitTicks(10)
        while not self:IsDead() and self.ActiveConsumption do
                        self:AddXP(self.XPnextLevel*levelPerSecond*0.05)            WaitTicks(30)
        end
    end,

    SetActiveConsumptionActive = function(self)
        if ScenarioInfo.ALLies != false then             if self.BuildXPThread then KillThread(self.BuildXPThread) end
            self.BuildXPThread = ForkThread(self.startBuildXPThread, self)
        end
        oldUnit.SetActiveConsumptionActive(self)
    end,

        startSiloXPThread = function(self)
        local levelPerSecond = self:GetBlueprint().Economy.BuildXPLevelpSecond
        if not levelPerSecond then return end
        if levelPerSecond <= 0 then return end
        WaitTicks(2)
        if not self:IsDead() and self:IsUnitState("SiloBuildingAmmo") then
            self:AddXP(self.XPnextLevel*levelPerSecond*0.016)
        else
            return
        end
        WaitTicks(10)
        if not self:IsDead() and self:IsUnitState("SiloBuildingAmmo") then
            self:AddXP(self.XPnextLevel*levelPerSecond*0.016)
        else
            return
        end
        WaitTicks(10)
        if not self:IsDead() and self:IsUnitState("SiloBuildingAmmo") then
            self:AddXP(self.XPnextLevel*levelPerSecond*0.016)
        else
            return
        end
        WaitTicks(10)
        while not self:IsDead() and self:IsUnitState("SiloBuildingAmmo") do
                        self:AddXP(self.XPnextLevel*levelPerSecond*0.05)
            WaitTicks(60)
        end
    end,
    OnSiloBuildStart = function(self, weapon)
        if self.SiloXPThread then KillThread(self.SiloXPThread) end
        self.SiloXPThread = ForkThread(self.startSiloXPThread, self)
        oldUnit.OnSiloBuildStart(self, weapon)
    end,


        SetVeterancy = function(self, veteranLevel)
        veteranLevel = veteranLevel or 0
        if veteranLevel <= 5 then
            return oldUnit.SetVeterancy(self, veteranLevel)
        else
            local bp = self:GetBlueprint()            if bp.Veteran['Level'..veteranLevel] then
                self:AddKills(bp.Veteran['Level'..veteranLevel])
            else
                WARN('SetVeterancy called on ' .. self:GetUnitId()
                .. ' with veteran level ' .. veteranLevel
                .. ' which was not defined in its BP file. '
                .. ' Veterancy level has not been set.'
                )
            end
        end
    end,

        CheckVeteranLevel = function(self)
        if not self.XPnextLevel then return end
        local bp = self:GetBlueprint()
        while self.xp >= self.XPnextLevel do
            self.xp = self.xp - self.XPnextLevel
            self.XPnextLevel = bp.Economy.XPperLevel * (1+ 0.1*self.VeteranLevel)
            self:SetVeteranLevel(self.VeteranLevel + 1)                    end
        self.LevelProgress = self.xp / self.XPnextLevel + self.VeteranLevel
        self.Sync.LevelProgress = self.LevelProgress
    end,

    PlayVeteranFx = function(self,time)
        if self.disableSFX == true then return end
        time = time or 1
        CreateAttachedEmitter(self, 0, self:GetArmy(), '/effects/emitters/destruction_explosion_concussion_ring_01_emit.bp'):ScaleEmitter(time)
    end,


            SetVeteranLevel = function(self, level)

                        self.VeteranLevel = level


                local buffTypes = {
            'Health',
            'Regen',
            'Vision',
            'Damage',
            'DamageArea',
            'Range',
            'RateOfFire',
            'Speed',
            'BuildRate',
            'Radar',
            'Sonar',
            'OmniRadius',
            'ResourceProduction',
            'Shield'
        }
                                Buff.ApplyBuff( self, 'VeterancyHealth')
        Buff.ApplyBuff( self, 'VeterancyRegen')
        Buff.ApplyBuff( self, 'VeterancyVision')
        local bp = self:GetBlueprint()
        local brain = GetArmyBrain(self:GetArmy())
        local gotweapon = false
        if bp.Weapon then
            for k,v in bp.Weapon do
                if v.Label != 'DeathWeapon' then
                    Buff.ApplyBuff( self, 'VeterancyDamage')
                    Buff.ApplyBuff( self, 'VeterancyDamageArea')
                    Buff.ApplyBuff( self, 'VeterancyRange')
                    Buff.ApplyBuff( self, 'VeterancyRateOfFire')
                    gotweapon = true
                    break
                end
            end
        end
        if EntityCategoryContains(categories.MOBILE, self) and not EntityCategoryContains(categories.AIR, self) then
            Buff.ApplyBuff( self, 'VeterancySpeed')
        end
        if self:GetBuildRate() and self:GetBuildRate() > 2 then
            Buff.ApplyBuff( self, 'VeterancyBuildRate')
        end
        if bp.Intel.RadarRadius and bp.Intel.RadarRadius > 0 then
            Buff.ApplyBuff( self, 'VeterancyRadar')
        end
        if bp.Intel.SonarRadius and bp.Intel.SonarRadius > 0 then
            Buff.ApplyBuff( self, 'VeterancySonar')
        end
        if bp.Intel.OmniRadius and bp.Intel.OmniRadius > 0 then
            Buff.ApplyBuff( self, 'VeterancyOmniRadius')
        end
        if (bp.Economy.ProductionPerSecondEnergy and bp.Economy.ProductionPerSecondEnergy > 0) or (bp.Economy.ProductionPerSecondMass and bp.Economy.ProductionPerSecondMass > 0) then
            Buff.ApplyBuff( self, 'VeterancyResourceProduction')
        end
        local gotShield = false
        if EntityCategoryContains(categories.COMMAND, self) or EntityCategoryContains(categories.SUBCOMMANDER, self) then

            Buff.ApplyBuff( self, 'VeterancyCommandProduction')

            Buff.ApplyBuff( self, 'VeterancySpeed2')

            if self.VeteranLevel == 101 then
                for i = 1, self:GetWeaponCount() do
                    local wep = self:GetWeapon(i)
                    local wepbp = wep:GetBlueprint()
                    if wep.Label != 'DeathWeapon' then
                        wep:SetFireTargetLayerCaps( 'Air|Land|Water|Seabed|Sub')
                        wepbp.FireTargetLayerCapsTable = {
                            Land = 'Air|Land|Water|Seabed|Sub',
                            Seabed = 'Air|Land|Water|Seabed|Sub',
                            Water = 'Air|Land|Water|Seabed|Sub',
                        }
                    end
                end
            end

            if not EntityCategoryContains(categories.CYBRAN, self) then
                gotShield = true
            end
        end        if self:GetShield() or gotShield then
            Buff.ApplyBuff( self, 'VeterancyShield')
        end
                local bpb = self:GetBlueprint().Buffs

        if bpb then
            for bLevel,bData in bpb do
                if (bLevel == 'Any' or bLevel == 'Level'..level) then
                                                            for bType,bValues in bData do
                        local buffName = self:CreateUnitBuff(bLevel,bType,bValues)
                        if buffName then
                            Buff.ApplyBuff( self, buffName )
                        end
                    end
                end
            end
        end

        if gotweapon then             if level == 6 then self.pFx = ForkThread(self.PlayVeteranFx, self,0.5) end
            if math.mod(level,10) == 1 then
                if self.pFx then KillThread(self.pFx) end
                self.pFx = ForkThread(self.PlayVeteranFx,self,level*0.1)
            end
            if math.mod(level,25) == 1 then
                if EntityCategoryContains(categories.MOBILE - categories.AIR, self) then
                    if brain.BrainType == "Human" then
                        local revive = self.Revive or 0
                        local revadd = 1
                        if self.Revive > 2 and ScenarioInfo.ALLies == false then
                            revadd = 0
                        end
                        self.Revive = revive + revadd
                        self.Sync.Revive = self.Revive
                    end
                end
            end
        end

        if brain.BrainType == "Human" and not brain.StorageEnergyTotal then
            brain.StorageEnergyTotal = 0
        end         if brain.BrainType == "Human" and not brain.StorageMassTotal then
            brain.StorageMassTotal = 0
        end
        if brain.BrainType == "Human" and not brain.ME then
            brain.ME = 1
        end
        if bp.Economy.StorageMass then
            if brain.BrainType == "Human" then
                brain.StorageMassTotal = brain.StorageMassTotal + (bp.Economy.StorageMass*mstbuff)
            end
        end
        if bp.Economy.StorageEnergy then
            if brain.BrainType == "Human" then
                brain.StorageEnergyTotal = brain.StorageEnergyTotal + (bp.Economy.StorageEnergy*estbuff)
            end
        end
        if brain.ME then
            if brain.ME == 1 then
                if brain.StorageMassTotal then
                    brain:GiveStorage("MASS",brain.StorageMassTotal)
                end
            else
                if brain.StorageEnergyTotal then
                    brain:GiveStorage("ENERGY",brain.StorageEnergyTotal)
                end
            end
        end
        self:GetAIBrain():OnBrainUnitVeterancyLevel(self, level)
        self:DoUnitCallbacks('OnVeteran')
    end,

            CreateUnitBuff = function(self, levelName, buffType, buffValues)

                local buffName = self:GetUnitId() .. levelName .. buffType
        local buffMinLevel = nil
        local buffMaxLevel = nil
        if buffValues.MinLevel then buffMinLevel = buffValues.MinLevel end
        if buffValues.MaxLevel then buffMaxLevel = buffValues.MaxLevel end


                if not Buffs[buffName] then
                        BuffBlueprint {
                MinLevel = buffMinLevel,
                MaxLevel = buffMaxLevel,
                Name = buffName,
                DisplayName = buffName,
                BuffType = buffType,
                Stacks = buffValues.Stacks,
                                Duration = buffValues.Duration,
                Affects = buffValues.Affects,
            }
        end

                return buffName
    end,

        UpdateProductionValues = function(self)
        local bpEcon = self:GetBlueprint().Economy
        if not bpEcon then return end
        self:SetProductionPerSecondEnergy( (self.EnergyProdMod or bpEcon.ProductionPerSecondEnergy or 0)* (self.EnergyProdAdjMod or 1) )
        self:SetProductionPerSecondMass( (self.MassProdMod or bpEcon.ProductionPerSecondMass or 0) * (self.MassProdAdjMod or 1) )
    end,

    AddLevels = function(self, levels)
        if levels < 0 then return end
        local bp = self:GetBlueprint()
        local curlevel = self.VeteranLevel
        local percent = self.LevelProgress - curlevel
        local xpAdd = 0
        if levels >= (1-percent) then
            xpAdd = self.XPnextLevel * (1-percent)
            levels=levels-(1-percent)
        else
            xpAdd =self.XPnextLevel * levels
            levels=0
        end
        while levels > 1 do
            levels=levels-1
            curlevel = curlevel +1
            xpAdd=xpAdd + bp.Economy.XPperLevel * (1+ 0.1*curlevel)
        end
        xpAdd=xpAdd + bp.Economy.XPperLevel * (1+ 0.1*(curlevel+1)) * levels
        self:AddXP(xpAdd)     end,

    AddXP = function(self,amount)
        if not self.XPnextLevel then return end
        if amount <= 0 then return end
        self.xp = self.xp + (amount)        self:CheckVeteranLevel()
    end,

    OnKilled = function(self, instigator, type, overkillRatio)
        local bp = self:GetBlueprint()
        local brain = GetArmyBrain(self:GetArmy())

        if bp.Economy.StorageEnergy and self.VeteranLevel > 1 then
            if brain.BrainType == "Human" then
                brain.StorageEnergyTotal = brain.StorageEnergyTotal - (bp.Economy.StorageEnergy*estbuff)*(self.VeteranLevel - 1)
                brain:GiveStorage("ENERGY",brain.StorageEnergyTotal)
            end
        end
        if bp.Economy.StorageMass and self.VeteranLevel > 1 then
            if brain.BrainType == "Human" then
                brain.StorageMassTotal = brain.StorageMassTotal - (bp.Economy.StorageMass*estbuff)*(self.VeteranLevel-1)
                brain:GiveStorage("MASS",brain.StorageMassTotal)
            end
        end
        if self.Revive > 0 and not brain:IsDefeated() then
            local unitEnhancements = import('/lua/enhancementcommon.lua').GetEnhancements(self:GetEntityId())
            local   where  = self:GetPosition()
            local  revivee = CreateUnitHPR(self:GetUnitId(), self:GetArmy(), where[1],where[2],where[3],0,0,0)
            revivee:SetCanBeKilled(false)
            revivee:SetCanTakeDamage(false)
            revivee:SetFireState(1)
            if unitEnhancements then
                for k,v in unitEnhancements do
                    if (v == 'StealthGenerator') then
                        revivee:CreateEnhancement('CloakingGenerator')
                    end
                    if (v == 'ShieldHeavy') or (v == 'ShieldGeneratorField') then
                        revivee:CreateEnhancement('Shield')
                    end
                    revivee:CreateEnhancement(v)
                end
            end
                        local lvl = math.floor(self.VeteranLevel)
            revivee:AddLevels(lvl-10)
            revivee:SetHealth(nil,1)
            local reviveelvl = revivee.VeteranLevel
            local br = revivee:GetBuildRate()
            local brRatio = reviveelvl/br
            revivee:SetBuildRate(0)
            revivee.Revive = self.Revive - 1
            revivee.Sync.Revive = revivee.Revive
            local id = revivee:GetEntityId()
            ForkThread(function()
                local timer = self.VeteranLevel*10
                if timer > 600 then
                    timer = 600
                    if ScenarioInfo.ALLies == false then timer = 450 end
                end
                local name = ''
                if brain.Nickname then
                    name = brain.Nickname
                end
                PrintText(name .. "'s Elite Veteran revived at Level " .. math.floor(revivee.VeteranLevel) ..  ' !!', 20, 'FFFF0000', 10, 'center')
                PrintText("It'll be Invincible for " .. math.floor(timer*0.1) ..  ' seconds !!', 10, 'FFFF0000', 5, 'center')
                for i = timer,1,-1 do
                    if not revivee:IsDead() then
                        if math.mod(i,10) == 0 then FloatingEntityText(id, i*0.1) end
                        revivee:SetFireState(1)
                        WaitTicks(1)
                    end
                end
                if not revivee:IsDead() then
                    revivee:SetCanBeKilled(true)
                    revivee:SetCanTakeDamage(true)
                    revivee:SetBuildRate(br)
                    revivee:SetFireState(0)
                end
            end)
        end

        if instigator and IsUnit(instigator) and not instigator:IsDead() then
            if bp.Economy.xpValue then
                local sLevel = self.VeteranLevel
                local xpR = sLevel                 instigator:AddXP(bp.Economy.xpValue*xpR*0.25)
            end
        end
        oldUnit.OnKilled(self, instigator, type, overkillRatio)
    end,

    CreateShield = function(self, shieldSpec)
        oldUnit.CreateShield(self, shieldSpec)
        Buff.BuffAffectUnit(self,'VeterancyShield', self, true)
    end,

    CreatePersonalShield = function(self, shieldSpec)
        oldUnit.CreatePersonalShield(self, shieldSpec)
        Buff.BuffAffectUnit(self,'VeterancyShield', self, true)
    end,

    InitiateTeleportThread = function(self, teleporter, location, orientation)
        local tbp = teleporter:GetBlueprint()
        local ubp = self:GetBlueprint()
        self.UnitBeingTeleported = self
        self:SetImmobile(true)
        self:PlayUnitSound('TeleportStart')
        self:PlayUnitAmbientSound('TeleportLoop')
        local bp = self:GetBlueprint().Economy
        local energyCost, time
        if bp then
            local mass = bp.BuildCostMass * (bp.TeleportMassMod or 0.01)
            local energy = bp.BuildCostEnergy * (bp.TeleportEnergyMod or 0.01)
            energyCost = mass + energy
            time = energyCost * (bp.TeleportTimeMod or 0.01)
            if ScenarioInfo.ALLies == false then
                                if EntityCategoryContains(categories.COMMAND, self) then
                    if (time - self.VeteranLevel*0.2) > 3 then                         time = time - (self.VeteranLevel*0.2)
                    else
                        time = 3
                    end
                elseif EntityCategoryContains(categories.SUBCOMMANDER, self) then
                    if (time - self.VeteranLevel*0.4) > 6 then                         time = time - (self.VeteranLevel*0.4)
                    else
                        time = 6
                    end
                else
                    if (time - self.VeteranLevel) > 10 then                         time = time - (self.VeteranLevel)
                    else
                        time = 10
                    end

                end
            else                if EntityCategoryContains(categories.COMMAND, self) then
                    if (time - self.VeteranLevel*0.5) > 0 then                         time = time - (self.VeteranLevel*0.5)
                    else
                        time = 0.1
                    end

                elseif EntityCategoryContains(categories.SUBCOMMANDER, self) then
                    if (time - self.VeteranLevel) > 0.2 then                         time = time - (self.VeteranLevel)
                    else
                        time = 0.2
                    end

                else
                    if (time - self.VeteranLevel) > 1 then                         time = time - (self.VeteranLevel)
                    else
                        time = 1
                    end
                end
            end
                                end

                self.TeleportDrain = CreateEconomyEvent(self, energyCost or 100, 0, time or 5, self.UpdateTeleportProgress)

                self:PlayTeleportChargeEffects()

        WaitFor( self.TeleportDrain  )
        if self.TeleportDrain then
            RemoveEconomyEvent(self, self.TeleportDrain )
            self.TeleportDrain = nil
        end

        self:PlayTeleportOutEffects()
        self:CleanupTeleportChargeEffects()

        WaitSeconds( 0.1 )

        self:SetWorkProgress(0.0)
        Warp(self, location, orientation)
        self:PlayTeleportInEffects()

        WaitSeconds( 0.1 )                         self:StopUnitAmbientSound('TeleportLoop')
        self:PlayUnitSound('TeleportEnd')
        self:SetImmobile(false)
        self.UnitBeingTeleported = nil
        self.TeleportThread = nil
    end,

    GetShield = function(self)
        return self.MyShield or nil
    end,
}
